'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.styles = styles;

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function styles(sourceMap) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref$cssPrefix = _ref.cssPrefix,
        cssPrefix = _ref$cssPrefix === undefined ? '' : _ref$cssPrefix,
        _ref$extract = _ref.extract,
        extract = _ref$extract === undefined ? false : _ref$extract,
        _ref$extractFilename = _ref.extractFilename,
        extractFilename = _ref$extractFilename === undefined ? '[name].css' : _ref$extractFilename,
        _ref$includePaths = _ref.includePaths,
        includePaths = _ref$includePaths === undefined ? [] : _ref$includePaths,
        _ref$postCssPlugins = _ref.postCssPlugins,
        postCssPlugins = _ref$postCssPlugins === undefined ? [] : _ref$postCssPlugins,
        _ref$handleUrl = _ref.handleUrl,
        handleUrl = _ref$handleUrl === undefined ? true : _ref$handleUrl;

    var cssUse = [{
        loader: 'css-loader',
        options: {
            sourceMap: sourceMap,
            minimize: true,
            camelCase: true,
            modules: true,
            importLoaders: 2,
            url: handleUrl,
            localIdentName: cssPrefix + '[local]'
        }
    }, {
        loader: 'postcss-loader',
        options: {
            plugins: function plugins() {
                return postCssPlugins;
            }
        }
    }];

    var scssUse = [].concat(_toConsumableArray(cssUse), [{
        loader: 'sass-loader',
        options: {
            includePaths: includePaths
        }
    }]);

    var lessUse = [].concat(_toConsumableArray(cssUse), [{
        loader: 'less-loader',
        options: {
            includePaths: includePaths
        }
    }]);

    var plugins = [];

    if (extract) {
        cssUse = _extractTextWebpackPlugin2.default.extract({ use: cssUse });
        scssUse = _extractTextWebpackPlugin2.default.extract({ use: scssUse });

        plugins.push(new _extractTextWebpackPlugin2.default({ filename: extractFilename, allChunks: true }));
    } else {
        cssUse = ['style-loader'].concat(_toConsumableArray(cssUse));
        scssUse = ['style-loader'].concat(_toConsumableArray(scssUse));
        lessUse = ['style-loader'].concat(_toConsumableArray(lessUse));
    }

    plugins = plugins.length > 0 ? { plugins: plugins } : {};

    return _extends({
        module: {
            rules: [{
                test: /\.scss$/,
                use: scssUse
            }, {
                test: /\.less$/,
                use: lessUse
            }, {
                test: /\.css$/,
                use: cssUse
            }]
        }
    }, plugins);
}